//=============================================================================
//
// file :         DaresburyClass.h
//
// description :  Include for the DaresburyClass root class.
//                This class is represents the singleton class for
//                the Daresbury device class.
//                It contains all properties and methods which the 
//                Daresbury requires only once e.g. the commands.
//			
// project :      TANGO Device Server
//
// $Author: jlpons $
//
// $Revision: 1.1 $
//
// $Log: not supported by cvs2svn $
//
// copyleft :     European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                FRANCE
//
//=============================================================================
//
//  		This file is generated by POGO
//	(Program Obviously used to Generate tango Object)
//
//         (c) - Software Engineering Group - ESRF
//=============================================================================

#ifndef _DARESBURYCLASS_H
#define _DARESBURYCLASS_H

#include <tango.h>


namespace Daresbury
{
//
// Define classes for commands
//
class ReadSerialCmd : public Tango::Command
{
public:
	ReadSerialCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	ReadSerialCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~ReadSerialCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};


class GetAllDescriptionCmd : public Tango::Command
{
public:
	GetAllDescriptionCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	GetAllDescriptionCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~GetAllDescriptionCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};


class ReadInterlockHistoryCmd : public Tango::Command
{
public:
	ReadInterlockHistoryCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	ReadInterlockHistoryCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~ReadInterlockHistoryCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};


class GetHistoryInfoCmd : public Tango::Command
{
public:
	GetHistoryInfoCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	GetHistoryInfoCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~GetHistoryInfoCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};


class SetInterlockDescriptionCmd : public Tango::Command
{
public:
	SetInterlockDescriptionCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	SetInterlockDescriptionCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~SetInterlockDescriptionCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};


class GetInterlockDescriptionCmd : public Tango::Command
{
public:
	GetInterlockDescriptionCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	GetInterlockDescriptionCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~GetInterlockDescriptionCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};


class ResetCmd : public Tango::Command
{
public:
	ResetCmd(const char *,Tango::CmdArgType, Tango::CmdArgType,const char *,const char *, Tango::DispLevel);
	ResetCmd(const char *,Tango::CmdArgType, Tango::CmdArgType);
	~ResetCmd() {};
	
	virtual bool is_allowed (Tango::DeviceImpl *, const CORBA::Any &);
	virtual CORBA::Any *execute (Tango::DeviceImpl *, const CORBA::Any &);
};



//
// The DaresburyClass singleton definition
//

class DaresburyClass : public Tango::DeviceClass
{
public:

//	add your own data members here
//------------------------------------

public:

//	Method prototypes
	static DaresburyClass *init(const char *);
	static DaresburyClass *instance();
	~DaresburyClass();
	
protected:
	DaresburyClass(string &);
	static DaresburyClass *_instance;
	void command_factory();
	void attribute_factory(vector<Tango::Attr *> &);
	void write_class_property();

private:
	void device_factory(const Tango::DevVarStringArray *);
};


}	//	namespace Daresbury

#endif // _DARESBURYCLASS_H
